﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Documents.Parsing;

namespace WpfApplication6
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();

			var vbLanguage = VisualBasicLanguage.Instance;

			// Clone the VB grammar so we can modify it.
			var customGrammar = vbLanguage.Grammar.Clone();

			// Replace the start symbol of the grammar so that a Block is expected as the file content, and not a CompilationUnit.
			// This will leave many symbols unused in the grammar and therefore removable if desired.
			customGrammar.StartSymbol = customGrammar.NonTerminalSymbols["Block"];

			// Create a language based on our cloned grammar and copy over the services from the VB language. 
			// The one we are really interested in is the indentation service provider.
			var customLanguage = new CustomLanguage(customGrammar);
			foreach (var serviceKey in vbLanguage.ServicesManager.GetRegisteredServiceKeys())
				customLanguage.ServicesManager.RegisterService(serviceKey, vbLanguage.ServicesManager.GetService(serviceKey));

			foreach (var serviceType in vbLanguage.ServicesManager.GetRegisteredServiceTypes())
				customLanguage.ServicesManager.RegisterService(serviceType, vbLanguage.ServicesManager.GetService(serviceType));

			// Set the language on the syntax editor.
			this.SyntaxEditor.Document.Language = customLanguage;
		}
	}
}
